typedef void (^AudioQueuePropertyListenerBlock)(AudioQueueRef inAQ, AudioQueuePropertyID inID);

static void AudioQueuePropertyListenerProcCallback(void* inUserData, AudioQueueRef inAQ, AudioQueuePropertyID inID) {
    AudioQueuePropertyListenerBlock block = inUserData;
    block(inAQ, inID);
}

OSStatus AudioQueueAddPropertyListenerBlock(AudioQueueRef inAQ,
                                            AudioQueuePropertyID inID,
                                            void (^inProc)(AudioQueueRef inAQ, AudioQueuePropertyID inID)) {
    return AudioQueueAddPropertyListener(inAQ, inID, &AudioQueuePropertyListenerProcCallback, inProc);
}

OSStatus AudioQueueRemovePropertyListenerBlock(AudioQueueRef inAQ,
                                               AudioQueuePropertyID inID,
                                               void* inUserData) {
    return AudioQueueRemovePropertyListener(inAQ, inID, &AudioQueuePropertyListenerProcCallback, inUserData);
}