typedef void (^outputBlock)(void* sourceFrameRefCon,
                            OSStatus status,
                            VTEncodeInfoFlags infoFlags,
                            CMSampleBufferRef sampleBuffer);

static void outputCallback(void* outputCallbackRefCon,
                           void* sourceFrameRefCon,
                           OSStatus status,
                           VTEncodeInfoFlags infoFlags,
                           CMSampleBufferRef sampleBuffer) {
    outputBlock outBlock = outputCallbackRefCon;
    outBlock(sourceFrameRefCon, status, infoFlags, sampleBuffer);
}

OSStatus VTCompressionSessionCreate_b(CFAllocatorRef allocator,
                                      int32_t width,
                                      int32_t height,
                                      CMVideoCodecType codecType,
                                      CFDictionaryRef encoderSpecification,
                                      CFDictionaryRef sourceImageBufferAttributes,
                                      CFAllocatorRef compressedDataAllocator,
                                      void (^outputBlock)(void* sourceFrameRefCon,
                                                          OSStatus status,
                                                          VTEncodeInfoFlags infoFlags,
                                                          CMSampleBufferRef sampleBuffer),
                                      VTCompressionSessionRef* compressionSessionOut) {

    void* outputCallbackRefCon = outputBlock;
    return VTCompressionSessionCreate(allocator,
                                      width,
                                      height,
                                      codecType,
                                      encoderSpecification,
                                      sourceImageBufferAttributes,
                                      compressedDataAllocator,
                                      &outputCallback,
                                      outputCallbackRefCon,
                                      compressionSessionOut);
}
