typedef void (^outputBlock)(void* sourceFrameRefCon,
                            OSStatus status,
                            VTDecodeInfoFlags infoFlags,
                            CVImageBufferRef imageBuffer,
                            CMTime presentationTimeStamp,
                            CMTime presentationDuration);

static void outputCallback(void* decompressionOutputRefCon,
                           void* sourceFrameRefCon,
                           OSStatus status,
                           VTDecodeInfoFlags infoFlags,
                           CVImageBufferRef imageBuffer,
                           CMTime presentationTimeStamp,
                           CMTime presentationDuration) {
    outputBlock outBlock = decompressionOutputRefCon;
    outBlock(sourceFrameRefCon, status, infoFlags, imageBuffer, presentationTimeStamp, presentationDuration);
}

OSStatus VTDecompressionSessionCreate_b(CFAllocatorRef allocator,
                                        CMVideoFormatDescriptionRef videoFormatDescription,
                                        CFDictionaryRef videoDecoderSpecification,
                                        CFDictionaryRef destinationImageBufferAttributes,
                                        void (^outputBlock)(void* sourceFrameRefCon,
                                                            OSStatus status,
                                                            VTDecodeInfoFlags infoFlags,
                                                            CVImageBufferRef imageBuffer,
                                                            CMTime presentationTimeStamp,
                                                            CMTime presentationDuration),
                                                            VTDecompressionSessionRef* decompressionSessionOut) {
    VTDecompressionOutputCallbackRecord record = { outputCallback, outputBlock };
    return VTDecompressionSessionCreate(allocator,
                                        videoFormatDescription,
                                        videoDecoderSpecification,
                                        destinationImageBufferAttributes,
                                        &record,
                                        decompressionSessionOut);
}
