typedef void (^clBuildProgram_notify)(cl_program);

static void clBuildProgram_notify_callback(cl_program program, void *user_data)
{
  clBuildProgram_notify notify = user_data;
  notify(program);
}

cl_int clBuildProgramBlock(cl_program program ,
               cl_uint num_devices,
               const cl_device_id *device_list,
               const char *options,
               clBuildProgram_notify notify)
{
  return clBuildProgram(program, num_devices, device_list, options, notify ? &clBuildProgram_notify_callback : NULL, notify);
}

typedef void (^clCreateContext_notify)(const char*, const void*, size_t);

static void clCreateContext_notify_callback(const char* errinfo, const void *private_info, size_t cb, void *user_data)
{
  clCreateContext_notify notify = user_data;
  notify(errinfo, private_info, cb);
}

cl_context clCreateContextBlock(const cl_context_properties *properties,
                cl_uint num_devices,
                const cl_device_id *devices,
                clCreateContext_notify notify,
                cl_int *errcode_ret)
{
  return clCreateContext(properties, num_devices, devices, notify ? &clCreateContext_notify_callback : NULL, notify, errcode_ret);
}
