//
// Draw a (wireframe) rectangular shape.
//
in vec2 v_RectCoordinate;
out vec4 out_FragColor;

uniform float width;
uniform float height;

bool inRange(float value, float minValue, float maxValue) {
    return value == clamp(value, minValue, maxValue);
}

void main() {

    float x = v_RectCoordinate.x;
    float y = v_RectCoordinate.y;

    if (((inRange(x, XOFF, XOFF + 1) || inRange(x, width - XOFF - 1, width - XOFF))
        && (inRange(y, YOFF, height - YOFF))) || ((inRange(y, YOFF, YOFF + 1) || inRange(y, height - YOFF - 1, height - YOFF))
        && (inRange(x, XOFF, width - XOFF)))) {
        out_FragColor = BORDER_COLOR;
    } else {
        out_FragColor = BG_COLOR;
    }
}

