//
// Draw a texture (video frame) on a rectangular shape.
//
in  vec2 in_TexCoordinate;
in  vec3 in_Position;
out vec2 texCoord0;

#ifdef FMT_NV12
out vec2 texCoord1;
#endif

#ifdef FMT_YUV_PLANAR
out vec2 texCoord1;
out vec2 texCoord2;
#endif

uniform vec2 scale;
uniform vec2 offset;

void main() {
  texCoord0 = in_TexCoordinate * scale + offset;

#ifdef FMT_NV12
  texCoord1 = texCoord0 * vec2(0.5, 0.5);
#endif
#ifdef FMT_YUV_PLANAR
  vec2 chromaScale = vec2(CHROMA_WSCALE, CHROMA_HSCALE);
  texCoord1 = texCoord0 * chromaScale;
  texCoord2 = texCoord0 * chromaScale;
#endif

  gl_Position = vec4(in_Position, 1.0);
}